version 12
clear all

// note that this program  modified tab2 to include 5-30 and 90k reps

cd "C:\Users\Hovk\Desktop\STATA Projects\interpolate_reg_2s\excel"


/////////////////////One sided two sample ///////////////////////////

mata:
	real scalar function elr(real colvector q1, real colvector qq)
		{
			real colvector m, rm, mm, L, LL, U, UU, qL, qU, F
			real rowvector temp, prodFmat
			real matrix Fmat
			real scalar q1n, qqn, elr
			
			q1n=rows(q1)
			qqn=rows(qq)

			m=(round(q1n^0.6)::min(( round(q1n^.9),round(q1n/2) )))

			rm=m#J(q1n,1,1)
			mm=J(rows(m),1,1)#(1::q1n)

			L=mm-rm
			LL=(L:*(L:>0))+(L:<=0)
			U=mm+rm
			UU=(U:*(U:<=q1n))+(U:>q1n)*q1n

			qL=q1[LL]
			qU=q1[UU]
			
			F=mm_relrank(qq,rows(qq),qU)-mm_relrank(qq,rows(qq),qL)
			F=editvalue(F,0,1/(qqn))

			F=(2*rm):/(q1n*F)
						
			Fmat=colshape(F,q1n)
			_transpose(Fmat)
				
			prodFmat=exp(colsum(log(Fmat)))
			
			elr=min(prodFmat)
		
			return(elr)
		}
end

////////////////////////// begin and branch by test ////////////////////////
mata:
	real rowvector dbelmc(real scalar cnum, real scalar n, real scalar m)
	{
		mcc=J(cnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
			x = sort(runiform(n, 1),1)
			y = sort(runiform(m, 1),1) 
			z = sort((x\y),1)	
			mcc[nn,1]=log(elr(x,z)*elr(y,z))
			++nn
			}
		c01=mm_quantile(mcc,1,0.99)
		c02=mm_quantile(mcc,1,0.98)
		c03=mm_quantile(mcc,1,0.97)
		c04=mm_quantile(mcc,1,0.96)
		c05=mm_quantile(mcc,1,0.95)	
		c06=mm_quantile(mcc,1,0.94)
		c07=mm_quantile(mcc,1,0.93)
		c08=mm_quantile(mcc,1,0.92)
		c09=mm_quantile(mcc,1,0.91)
		c10=mm_quantile(mcc,1,0.90)
		c11=mm_quantile(mcc,1,0.89)
		c12=mm_quantile(mcc,1,0.88)
		c13=mm_quantile(mcc,1,0.87)
		c14=mm_quantile(mcc,1,0.86)
		c15=mm_quantile(mcc,1,0.85)
		c16=mm_quantile(mcc,1,0.50)
		c17=mm_quantile(mcc,1,0.30)
		c18=mm_quantile(mcc,1,0.20)
		c19=mm_quantile(mcc,1,0.10)			
		
		outresult=(n,m,c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19)
		outresult
		return(outresult)
}
end


mata:
		mcCritical=J(800,21,9)
		qq=1
		n=5
		while (n<=200) {
			m=n
			while(m<=200) {
						//(qq,n,m)
						mcCritical[qq,1::21]=dbelmc(90000,n,m)
						if (100<=m & m<=200) m=m+50
						if (60<=m & m<=80) m=m+20
						if (40<=m & m<=50) m=m+10
						if (30<=m & m<=35) m=m+5
						if (5<=m & m<30) m=m+1
						++qq	
					}
					if (100<=n & n<=200) n=n+50
					if (60<=n & n<=80) n=n+20
					if (40<=n & n<=50) n=n+10
					if (30<=n & n<=35) n=n+5
					if (5<=n & n<30) n=n+1
			}
end

getmata (n m c01 c02 c03 c04 c05 c06 c07 c08 c09 c10 c11 c12 c13 c14 c15 c16 c17 c18 c19)=mcCritical, replace force
export excel n m  c01 c02 c03 c04 c05 c06 c07 c08 c09 c10 c11 c12 c13 c14 c15 c16 c17 c18 c19 using critval2s2s,  firstrow(variables) replace

