version 12
clear all


/////////////////////One sided one sample///////////////////////////

mata:
	real scalar function elr1sw(real colvector q1, real colvector qq)
		{
		
			real colvector m, rm, mm, L, LL, U, UU, qL, qU, F, Fnum, Fnum3
			real rowvector temp, prodFmat
			real matrix Fmat
			real scalar q1n, qqn, elr, Fnum1, Fnum2
			
			q1n=rows(q1)
			qqn=rows(qq)
			invqt=1/(q1n)

			m=(round(q1n^0.6)::min(( round(q1n^.9),round(q1n/2) )))

			rm=m#J(q1n,1,1)
			mm=J(rows(m),1,1)#(1::q1n)

			L=mm-rm
			LL=(L:*(L:>0))+(L:<=0)
			U=mm+rm
			UU=(U:*(U:<=q1n))+(U:>q1n)*q1n

			qL=q1[LL]
			qU=q1[UU]
			
		    F=rowmax((mm_relrank(q1,q1n,qU),mm_relrank(qq,qqn,qU)))-rowmax((mm_relrank(q1,q1n,qL),mm_relrank(qq,qqn,qL)))
			
			F=editvalue(F,0,invqt)

			Fnum1=2*rm
			Fnum2=1/(2*q1n)
			Fnum3=rm:+1
			Fnum=Fnum1:*(1:-(Fnum2*Fnum3))
			
			F=Fnum:/(q1n*F)
			Fmat=colshape(F,q1n)
			_transpose(Fmat)
			
			prodFmat=exp(colsum(log(Fmat)))
		
			elr=min(prodFmat)
	
			return(elr)
		}
end


////////////////////////// designA n(0,1) ////////////////////////

mata:
	real rowvector dbelmcA(real scalar cnum, real scalar pnum, real scalar n)
	{
		real scalar power
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(rnormal(n,1,0,1),1)
				y = sort(-x,1)
				mcc[nn,1]=log(elr1sw(x,y))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort(rnormal(n, 1, 0, 1),1)
				y = sort(-x,1)
				
				mcp[pp,1]=log(elr1sw(x,y))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,c05,power)
		return(outresult)
}
end

mata:
		mcA=J(9,3,9)
		qq=1
		for (n=5; n<=45; n=n+5) {
						mcA[qq,1::3]=dbelmcA(50000,10000,n)
						++qq
			}	
		mcA
end



////////////////////////// designB n(1,1) ////////////////////////

mata:
	real rowvector dbelmcB(real scalar cnum, real scalar pnum, real scalar n)
	{
		real scalar power
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(rnormal(n,1,0,1),1)
				y = sort(-x,1)
				mcc[nn,1]=log(elr1sw(x,y))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort(rnormal(n, 1, 1, 1),1)
				y = sort(-x,1)
				
				mcp[pp,1]=log(elr1sw(x,y))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,c05,power)
		return(outresult)
}
end

mata:
		mcB=J(9,3,9)
		qq=1
		for (n=5; n<=45; n=n+5) {
						mcB[qq,1::3]=dbelmcB(50000,10000,n)
						++qq
			}	
		mcB
end




////////////////////////// designC n(0.5,1) ////////////////////////

mata:
	real rowvector dbelmcC(real scalar cnum, real scalar pnum, real scalar n)
	{
		real scalar power
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(rnormal(n,1,0,1),1)
				y = sort(-x,1)
				mcc[nn,1]=log(elr1sw(x,y))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort(rnormal(n, 1, 0.5, 1),1)
				y = sort(-x,1)
				
				mcp[pp,1]=log(elr1sw(x,y))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,c05,power)
		return(outresult)
}
end

mata:
		mcC=J(9,3,9)
		qq=1
		for (n=5; n<=45; n=n+5) {
						mcC[qq,1::3]=dbelmcC(50000,10000,n)
						++qq
			}	
		mcC
end




////////////////////////// designD n(0.25,1) ////////////////////////

mata:
	real rowvector dbelmcD(real scalar cnum, real scalar pnum, real scalar n)
	{
		real scalar power
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(rnormal(n,1,0,1),1)
				y = sort(-x,1)
				mcc[nn,1]=log(elr1sw(x,y))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort(rnormal(n, 1, 0.25, 1),1)
				y = sort(-x,1)
				
				mcp[pp,1]=log(elr1sw(x,y))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,c05,power)
		return(outresult)
}
end

mata:
		mcD=J(9,3,9)
		qq=1
		for (n=5; n<=45; n=n+5) {
						mcD[qq,1::3]=dbelmcD(50000,10000,n)
						++qq
			}	
		mcD
end

////////////////////////// designQ n(0.1,1) ////////////////////////

mata:
	real rowvector dbelmcQ(real scalar cnum, real scalar pnum, real scalar n)
	{
		real scalar power
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(rnormal(n,1,0,1),1)
				y = sort(-x,1)
				mcc[nn,1]=log(elr1sw(x,y))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort(rnormal(n, 1, 0.1, 1),1)
				y = sort(-x,1)
				
				mcp[pp,1]=log(elr1sw(x,y))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,c05,power)
		return(outresult)
}
end

mata:
		mcQ=J(9,3,9)
		qq=1
		for (n=5; n<=45; n=n+5) {
						mcQ[qq,1::3]=dbelmcQ(50000,10000,n)
						++qq
			}	
		mcQ
end



////////////////////////// designE u(-0.3,0.7) ////////////////////////

mata:
	real rowvector dbelmcE(real scalar cnum, real scalar pnum, real scalar n)
	{
		real scalar power
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(rnormal(n,1,0,1),1)
				y = sort(-x,1)
				mcc[nn,1]=log(elr1sw(x,y))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort((0.7:+(-1:*runiform(n,1))),1)
				y = sort(-x,1)
				
				mcp[pp,1]=log(elr1sw(x,y))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,c05,power)
		return(outresult)
}
end

mata:
		mcE=J(9,3,9)
		qq=1
		for (n=5; n<=45; n=n+5) {
						mcE[qq,1::3]=dbelmcE(50000,10000,n)
						++qq
			}	
		mcE
end



////////////////////////// designF u(-0.5,1) ////////////////////////

mata:
	real rowvector dbelmcF(real scalar cnum, real scalar pnum, real scalar n)
	{
		real scalar power
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(rnormal(n,1,0,1),1)
				y = sort(-x,1)
				mcc[nn,1]=log(elr1sw(x,y))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort((1:+(-1.5:*runiform(n,1))),1)
				y = sort(-x,1)
				
				mcp[pp,1]=log(elr1sw(x,y))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,c05,power)
		return(outresult)
}
end

mata:
		mcF=J(9,3,9)
		qq=1
		for (n=5; n<=45; n=n+5) {
						mcF[qq,1::3]=dbelmcF(50000,10000,n)
						++qq
			}	
		mcF
end





////////////////////////// designW u(-0.8,1) ////////////////////////

mata:
	real rowvector dbelmcW(real scalar cnum, real scalar pnum, real scalar n)
	{
		real scalar power
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(rnormal(n,1,0,1),1)
				y = sort(-x,1)
				mcc[nn,1]=log(elr1sw(x,y))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort((1:+(-1.8:*runiform(n,1))),1)
				y = sort(-x,1)
				
				mcp[pp,1]=log(elr1sw(x,y))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,c05,power)
		return(outresult)
}
end

mata:
		mcW=J(9,3,9)
		qq=1
		for (n=5; n<=45; n=n+5) {
						mcW[qq,1::3]=dbelmcW(50000,10000,n)
						++qq
			}	
		mcW
end




////////////////////////// designR u(-1,1) ////////////////////////

mata:
	real rowvector dbelmcR(real scalar cnum, real scalar pnum, real scalar n)
	{
		real scalar power
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(rnormal(n,1,0,1),1)
				y = sort(-x,1)
				mcc[nn,1]=log(elr1sw(x,y))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort((1:+(-2:*runiform(n,1))),1)
				y = sort(-x,1)
				
				mcp[pp,1]=log(elr1sw(x,y))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,c05,power)
		return(outresult)
}
end

mata:
		mcR=J(9,3,9)
		qq=1
		for (n=5; n<=45; n=n+5) {
						mcR[qq,1::3]=dbelmcR(50000,10000,n)
						++qq
			}	
		mcR
end










mata:
	mcALL=(J(9,1,1),mcA\J(9,1,2),mcB\J(9,1,3),mcC\J(9,1,4),mcD\J(9,1,5),mcQ\J(9,1,6),mcE\J(9,1,7),mcF\J(9,1,8),mcW\J(9,1,9),mcR)
	mcALL

end

cd "E:\STATA Projects\Vexler2- DBEL Project-Tanajian-for WEB SITE\proportion rejected programs\onesample\onesampleonesided"
getmata (design n c05 power)=mcALL, replace force
export excel design n c05 power using tab1s1smc, firstrow(variables) replace   

