version 12
clear all


////////////////////// three sample test //////////////////////


//subset to A,B,E,F,J,M,N //

// designA:  n(0,1)x2:u(-1,1)
// designB:  exp(1)x2:lognormal(0,1)
// designC:  n(0,1)x2:n(0.5,1)
// designD:  n(0,1)x2:n(1.5,1)
// designE:  n(0,1)x2:n(0,1.5**2)
// designF:  n(0,1)x2:n(0,0.5**2)
// designG:  exp(1)x2:exp(1.5)
// designH:  beta(0.7,1)x2:exp(2)
// designI:	 n(0,1):u(0,1):n(0.2,2)
// designJ:  e(1):logN(0,1):u(0,1)
// designk:  u(0,1):u(0,1.5):u(0,1.3)
// designL:  n(0,1):n(0,1,5):n(0,1.3)
// designM:  u(0,1):u(0,1):u(0,1)
// designN:  e(1):e(1):e(1)



/////////////////////// designA ////////////////////////

mata:
	real rowvector anovaA(real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcp=J(pnum,1,0)
		
		pp=1
		while(pp<=pnum) {
				x=rnormal(n, 1, 0, 1)
				y=rnormal(m, 1, 0, 1)
				z=(-1:+(2:*runiform(p,1)))
				xyz=(x\y\z)
				
				mx=mean(x)
				my=mean(y)
				mz=mean(z)
				mxyz=mean(xyz)
				mmxyz=J(n,1,mx)\J(m,1,my)\J(p,1,mz)
		
				num=((n*((mx-mxyz)^2))+(m*((my-mxyz)^2))+(p*((mz-mxyz)^2)))/2
				den=((n+m+p)*mean((xyz:-mmxyz):^2))/(n+m+p-3)
				mcp[pp,1]=num/den
				++pp
			}
			
		c05=invF(2,m+n+p-3,0.95)
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}
end


mata:		
		mcA=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcA[qq,1::5]=anovaA(10000,n,m,p)			
		qq=2
		n=25
		m=25
		p=25
		mcA[qq,1::5]=anovaA(10000,n,m,p)
		qq=3
		n=37
		m=45
		p=50
		mcA[qq,1::5]=anovaA(10000,n,m,p)				
					
		mcA=(J(3,1,1),mcA)
		mcA
end



/////////////////////// designB ////////////////////////
			
mata:
	real rowvector anovaB(real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcp=J(pnum,1,0)
		
		pp=1
		while(pp<=pnum) {
				x = rgamma(n, 1, 1, 1) 
				y = rgamma(m, 1, 1, 1)
				z = exp(rnormal(p, 1, 0, 1))
				xyz=(x\y\z)
				
				mx=mean(x)
				my=mean(y)
				mz=mean(z)
				mxyz=mean(xyz)
				mmxyz=J(n,1,mx)\J(m,1,my)\J(p,1,mz)
		
				num=((n*((mx-mxyz)^2))+(m*((my-mxyz)^2))+(p*((mz-mxyz)^2)))/2
				den=((n+m+p)*mean((xyz:-mmxyz):^2))/(n+m+p-3)
				mcp[pp,1]=num/den
				++pp
			}
			
		c05=invF(2,m+n+p-3,0.95)
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}
end


mata:		
		mcB=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcB[qq,1::5]=anovaB(10000,n,m,p)			
		qq=2
		n=25
		m=25
		p=25
		mcB[qq,1::5]=anovaB(10000,n,m,p)
		qq=3
		n=37
		m=45
		p=50
		mcB[qq,1::5]=anovaB(10000,n,m,p)				
					
		mcB=(J(3,1,1),mcB)
		mcB
end



///////////////// designE //////////////////
			
mata:
	real rowvector anovaE(real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcp=J(pnum,1,0)
		
		pp=1
		while(pp<=pnum) {
				x=rnormal(n, 1, 0, 1)
				y=rnormal(m, 1, 0, 1)
				z=rnormal(p, 1, 0, 2.25)
				xyz=(x\y\z)
				
				mx=mean(x)
				my=mean(y)
				mz=mean(z)
				mxyz=mean(xyz)
				mmxyz=J(n,1,mx)\J(m,1,my)\J(p,1,mz)
		
				num=((n*((mx-mxyz)^2))+(m*((my-mxyz)^2))+(p*((mz-mxyz)^2)))/2
				den=((n+m+p)*mean((xyz:-mmxyz):^2))/(n+m+p-3)
				mcp[pp,1]=num/den
				++pp
			}
			
		c05=invF(2,m+n+p-3,0.95)
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}
end						

mata:		
		mcE=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcE[qq,1::5]=anovaE(10000,n,m,p)			
		qq=2
		n=25
		m=25
		p=25
		mcE[qq,1::5]=anovaE(10000,n,m,p)
		qq=3
		n=37
		m=45
		p=50
		mcE[qq,1::5]=anovaE(10000,n,m,p)				
					
		mcE=(J(3,1,1),mcE)
		mcE
end


///////////////// designF //////////////////
			
mata:
	real rowvector anovaF(real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcp=J(pnum,1,0)
		
		pp=1
		while(pp<=pnum) {
				x=rnormal(n, 1, 0, 1)
				y=rnormal(m, 1, 0, 1)
				z=rnormal(p, 1, 0, 0.25)
				xyz=(x\y\z)
				
				mx=mean(x)
				my=mean(y)
				mz=mean(z)
				mxyz=mean(xyz)
				mmxyz=J(n,1,mx)\J(m,1,my)\J(p,1,mz)
		
				num=((n*((mx-mxyz)^2))+(m*((my-mxyz)^2))+(p*((mz-mxyz)^2)))/2
				den=((n+m+p)*mean((xyz:-mmxyz):^2))/(n+m+p-3)
				mcp[pp,1]=num/den
				++pp
			}
			
		c05=invF(2,m+n+p-3,0.95)
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}
end						


mata:		
		mcF=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcF[qq,1::5]=anovaF(10000,n,m,p)			
		qq=2
		n=25
		m=25
		p=25
		mcF[qq,1::5]=anovaF(10000,n,m,p)
		qq=3
		n=37
		m=45
		p=50
		mcF[qq,1::5]=anovaF(10000,n,m,p)				
					
		mcF=(J(3,1,1),mcF)
		mcF
end



/////////////////////// designJ ////////////////////////

mata:
	real rowvector anovaJ(real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcp=J(pnum,1,0)
		
		pp=1
		while(pp<=pnum) {
				x = rgamma(n, 1, 1, 1) 
				y = exp(rnormal(m, 1, 0, 1))
				z = runiform(p, 1) 
				xyz=(x\y\z)
				
				mx=mean(x)
				my=mean(y)
				mz=mean(z)
				mxyz=mean(xyz)
				mmxyz=J(n,1,mx)\J(m,1,my)\J(p,1,mz)
		
				num=((n*((mx-mxyz)^2))+(m*((my-mxyz)^2))+(p*((mz-mxyz)^2)))/2
				den=((n+m+p)*mean((xyz:-mmxyz):^2))/(n+m+p-3)
				mcp[pp,1]=num/den
				++pp
			}
			
		c05=invF(2,m+n+p-3,0.95)
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}							


mata:		
		mcJ=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcJ[qq,1::5]=anovaJ(10000,n,m,p)			
		qq=2
		n=25
		m=25
		p=25
		mcJ[qq,1::5]=anovaJ(10000,n,m,p)
		qq=3
		n=37
		m=45
		p=50
		mcJ[qq,1::5]=anovaJ(10000,n,m,p)				
					
		mcJ=(J(3,1,1),mcJ)
		mcJ
end


	
/////////////////////// designM ////////////////////////

mata:
	real rowvector anovaM(real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcp=J(pnum,1,0)
		
		pp=1
		while(pp<=pnum) {
				x = runiform(m, 1) 
				y = runiform(n, 1) 
				z = runiform(p, 1) 
				xyz=(x\y\z)
				
				mx=mean(x)
				my=mean(y)
				mz=mean(z)
				mxyz=mean(xyz)
				mmxyz=J(n,1,mx)\J(m,1,my)\J(p,1,mz)
		
				num=((n*((mx-mxyz)^2))+(m*((my-mxyz)^2))+(p*((mz-mxyz)^2)))/2
				den=((n+m+p)*mean((xyz:-mmxyz):^2))/(n+m+p-3)
				mcp[pp,1]=num/den
				++pp
			}
			
		c05=invF(2,m+n+p-3,0.95)
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}						

mata:		
		mcM=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcM[qq,1::5]=anovaM(10000,n,m,p)			
		qq=2
		n=25
		m=25
		p=25
		mcM[qq,1::5]=anovaM(10000,n,m,p)
		qq=3
		n=37
		m=45
		p=50
		mcM[qq,1::5]=anovaM(10000,n,m,p)				
					
		mcM=(J(3,1,1),mcM)
		mcM
end

	
		

/////////////////////// designN ////////////////////////

mata:
	real rowvector anovaN(real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcp=J(pnum,1,0)
		
		pp=1
		while(pp<=pnum) {
				x = rnormal(n, 1, 0, 1)
				y = rnormal(m, 1, 0, 1)
				z = rnormal(p, 1, 0, 1)
				
				xyz=(x\y\z)
				
				mx=mean(x)
				my=mean(y)
				mz=mean(z)
				mxyz=mean(xyz)
				mmxyz=J(n,1,mx)\J(m,1,my)\J(p,1,mz)
		
				num=((n*((mx-mxyz)^2))+(m*((my-mxyz)^2))+(p*((mz-mxyz)^2)))/2
				den=((n+m+p)*mean((xyz:-mmxyz):^2))/(n+m+p-3)
				mcp[pp,1]=num/den
				++pp
			}
			
		c05=invF(2,m+n+p-3,0.95)
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}	

mata:		
		mcN=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcN[qq,1::5]=anovaN(10000,n,m,p)			
		qq=2
		n=25
		m=25
		p=25
		mcN[qq,1::5]=anovaN(10000,n,m,p)
		qq=3
		n=37
		m=45
		p=50
		mcN[qq,1::5]=anovaN(10000,n,m,p)				
					
		mcN=(J(3,1,1),mcN)
		mcN
			
end

		

/////////////////////// designP ////////////////////////

mata:
	real rowvector anovaP(real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcp=J(pnum,1,0)
		
		pp=1
		while(pp<=pnum) {
				x = rgamma(n, 1, 1, 1)
				y = rgamma(m, 1, 1, 1)
				z = rgamma(p, 1, 1, 1)
				
				xyz=(x\y\z)
				
				mx=mean(x)
				my=mean(y)
				mz=mean(z)
				mxyz=mean(xyz)
				mmxyz=J(n,1,mx)\J(m,1,my)\J(p,1,mz)
		
				num=((n*((mx-mxyz)^2))+(m*((my-mxyz)^2))+(p*((mz-mxyz)^2)))/2
				den=((n+m+p)*mean((xyz:-mmxyz):^2))/(n+m+p-3)
				mcp[pp,1]=num/den
				++pp
			}
			
		c05=invF(2,m+n+p-3,0.95)
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}	

mata:		
		mcP=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcP[qq,1::5]=anovaP(10000,n,m,p)			
		qq=2
		n=25
		m=25
		p=25
		mcP[qq,1::5]=anovaP(10000,n,m,p)
		qq=3
		n=37
		m=45
		p=50
		mcP[qq,1::5]=anovaP(10000,n,m,p)				
					
		mcP=(J(3,1,1),mcP)
		mcP
end


mata:		
		
		mc=(mcA\mcB\mcE\mcF\mcJ\mcM\mcN\mcP)
		
end



cd "E:\STATA Projects\Vexler2- DBEL Project-Tanajian-for WEB SITE\proportion rejected programs\threesample"
getmata (design n m p c05 power)=mc, replace force
export excel design n m p c05 power using prop_rej_3sAnova_sub, firstrow(variables) replace




