version 12
clear all


////////////////////// three sample test //////////////////////

mata:
	real scalar function elr3s(real colvector q1, real colvector qq)
		{
			real colvector m, rm, mm, L, LL, U, UU, qL, qU, F
			real rowvector temp, prodFmat
			real matrix Fmat
			real scalar q1n, qqn, elr
			
			q1n=rows(q1)
			qqn=rows(qq)

			m=(round(q1n^0.6)::min(( round(q1n^.9),round(q1n/2) )))

			rm=m#J(q1n,1,1)
			mm=J(rows(m),1,1)#(1::q1n)

			L=mm-rm
			LL=(L:*(L:>0))+(L:<=0)
			U=mm+rm
			UU=(U:*(U:<=q1n))+(U:>q1n)*q1n

			qL=q1[LL]
			qU=q1[UU]
			
			F=mm_relrank(qq,rows(qq),qU)-mm_relrank(qq,rows(qq),qL)
			F=editvalue(F,0,1/(qqn))

			F=(2*rm):/(q1n*F)
						
			Fmat=colshape(F,q1n)
			_transpose(Fmat)
				
			prodFmat=exp(colsum(log(Fmat)))
			
			elr=min(prodFmat)
			
			return(elr)
		}
end


//subset to A,B,E,F,J,M,N //

// designA:  n(0,1)x2:u(-1,1)
// designB:  exp(1)x2:lognormal(0,1)
// designC:  n(0,1)x2:n(0.5,1)
// designD:  n(0,1)x2:n(1.5,1)
// designE:  n(0,1)x2:n(0,1.5**2)
// designF:  n(0,1)x2:n(0,0.5**2)
// designG:  exp(1)x2:exp(1.5)
// designH:  beta(0.7,1)x2:exp(2)
// designI:	 n(0,1):u(0,1):n(0.2,2)
// designJ:  e(1):logN(0,1):u(0,1)
// designk:  u(0,1):u(0,1.5):u(0,1.3)
// designL:  n(0,1):n(0,1,5):n(0,1.3)
// designm:  u(0,1)x3
// designx:  e(1)x3
// designn:  n(0,1)x3



/////////////////////// designA ////////////////////////

mata:
	real rowvector dbelmcA(real scalar cnum, real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 
				z = sort(runiform(p, 1),1) 
				xyz = sort((x\y\z),1)	
				mcc[nn,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x=sort(rnormal(n, 1, 0, 1),1)
				y=sort(rnormal(m, 1, 0, 1),1)
				z=sort((-1:+(2:*runiform(p,1))),1)
				xyz=sort((x\y\z),1)
				mcp[pp,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}
end


mata:		
		mcA=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcA[qq,1::5]=dbelmcA(30000,10000,n,m,p)				
		qq=2
		n=25
		m=25
		p=25
		mcA[qq,1::5]=dbelmcA(30000,10000,n,m,p)
		qq=3
		n=37
		m=45
		p=50
		mcA[qq,1::5]=dbelmcA(30000,10000,n,m,p)					
					
		mcA=(J(3,1,1),mcA)
		mcA
end


/////////////////////// designB ////////////////////////

mata:
	real rowvector dbelmcB(real scalar cnum, real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 
				z = sort(runiform(p, 1),1) 
				xyz = sort((x\y\z),1)	
				mcc[nn,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort(rgamma(n, 1, 1, 1),1) 
				y = sort(rgamma(m, 1, 1, 1),1)
				z = sort(exp(rnormal(p, 1, 0, 1)),1)
				xyz=sort((x\y\z),1)
				mcp[pp,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}
end


mata:	
		mcB=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcB[qq,1::5]=dbelmcB(30000,10000,n,m,p)				
		qq=2
		n=25
		m=25
		p=25
		mcB[qq,1::5]=dbelmcB(30000,10000,n,m,p)	
		qq=3
		n=37
		m=45
		p=50
		mcB[qq,1::5]=dbelmcB(30000,10000,n,m,p)				
					
		mcB=(J(3,1,2),mcB)
		mcB
end




///////////////// designE //////////////////

mata:
	real rowvector dbelmcE(real scalar cnum, real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 
				z = sort(runiform(p, 1),1) 
				xyz = sort((x\y\z),1)	
				mcc[nn,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x=sort(rnormal(n, 1, 0, 1),1)
				y=sort(rnormal(m, 1, 0, 1),1)
				z=sort(rnormal(p, 1, 0, 2.25),1)
				xyz=sort((x\y\z),1)
				mcp[pp,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}
end


mata:	
		mcE=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcE[qq,1::5]=dbelmcE(30000,10000,n,m,p)				
		qq=2
		n=25
		m=25
		p=25
		mcE[qq,1::5]=dbelmcE(30000,10000,n,m,p)	
		qq=3
		n=37
		m=45
		p=50
		mcE[qq,1::5]=dbelmcE(30000,10000,n,m,p)				
					
		mcE=(J(3,1,3),mcE)
		mcE
end



///////////////// designF //////////////////

mata:
	real rowvector dbelmcF(real scalar cnum, real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 
				z = sort(runiform(p, 1),1) 
				xyz = sort((x\y\z),1)	
				mcc[nn,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x=sort(rnormal(n, 1, 0, 1),1)
				y=sort(rnormal(m, 1, 0, 1),1)
				z=sort(rnormal(p, 1, 0, 0.25),1)
				xyz=sort((x\y\z),1)
				mcp[pp,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}
end


mata:	
		mcF=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcF[qq,1::5]=dbelmcF(30000,10000,n,m,p)				
		qq=2
		n=25
		m=25
		p=25
		mcF[qq,1::5]=dbelmcF(30000,10000,n,m,p)	
		qq=3
		n=37
		m=45
		p=50
		mcF[qq,1::5]=dbelmcF(30000,10000,n,m,p)				
					
		mcF=(J(3,1,4),mcF)
		mcF
end





/////////////////////// designJ ////////////////////////

mata:
	real rowvector dbelmcJ(real scalar cnum, real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 
				z = sort(runiform(p, 1),1) 
				xyz = sort((x\y\z),1)	
				mcc[nn,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort(rgamma(n, 1, 1, 1),1) 
				y = sort(exp(rnormal(m, 1, 0, 1)),1)
				z = sort(runiform(p, 1),1) 
				xyz=sort((x\y\z),1)
				mcp[pp,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}
end


mata:	
		mcJ=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcJ[qq,1::5]=dbelmcJ(30000,10000,n,m,p)				
		qq=2
		n=25
		m=25
		p=25
		mcJ[qq,1::5]=dbelmcJ(30000,10000,n,m,p)	
		qq=3
		n=37
		m=45
		p=50
		mcJ[qq,1::5]=dbelmcJ(30000,10000,n,m,p)			
					
		mcJ=(J(3,1,5),mcJ)
		mcJ
end






/////////////////////// designM ////////////////////////

mata:
	real rowvector dbelmcM(real scalar cnum, real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 
				z = sort(runiform(p, 1),1) 
				xyz = sort((x\y\z),1)	
				mcc[nn,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 
				z = sort(runiform(p, 1),1) 
				xyz=sort((x\y\z),1)
				mcp[pp,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}
end



mata:	
		mcM=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcM[qq,1::5]=dbelmcM(30000,10000,n,m,p)				
		qq=2
		n=25
		m=25
		p=25
		mcM[qq,1::5]=dbelmcM(30000,10000,n,m,p)				
		qq=3
		n=37
		m=45
		p=50
		mcM[qq,1::5]=dbelmcM(30000,10000,n,m,p)			
		mcM=(J(3,1,6),mcM)
		mcM
end




/////////////////////// designN////////////////////////

mata:
	real rowvector dbelmcN(real scalar cnum, real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 
				z = sort(runiform(p, 1),1) 
				xyz = sort((x\y\z),1)	
				mcc[nn,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort(rnormal(n, 1, 0, 1),1)
				y = sort(rnormal(m, 1, 0, 1),1)
				z = sort(rnormal(p, 1, 0, 1),1)
				xyz=sort((x\y\z),1)
				mcp[pp,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}
end


mata:	
		mcN=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcN[qq,1::5]=dbelmcN(30000,10000,n,m,p)				
		qq=2
		n=25
		m=25
		p=25
		mcN[qq,1::5]=dbelmcN(30000,10000,n,m,p)				
		qq=3
		n=37
		m=45
		p=50
		mcN[qq,1::5]=dbelmcN(30000,10000,n,m,p)	
		
		mcN=(J(3,1,6),mcN)
		mcN
end



/////////////////////// designP////////////////////////

mata:
	real rowvector dbelmcP(real scalar cnum, real scalar pnum, real scalar n, real scalar m, real scalar p)
	{
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 
				z = sort(runiform(p, 1),1) 
				xyz = sort((x\y\z),1)	
				mcc[nn,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				x = sort(rgamma(n, 1, 1, 1),1)
				y = sort(rgamma(m, 1, 1, 1),1)
				z = sort(rgamma(p, 1, 1, 1),1)
				xyz=sort((x\y\z),1)
				mcp[pp,1]=log(elr3s(x,xyz)*elr3s(y,xyz)*elr3s(z,xyz))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,p,c05,power)
		return(outresult)
}
end


mata:	
		mcP=J(3,5,9)
		qq=1
		n=25
		m=15
		p=20
		mcP[qq,1::5]=dbelmcP(30000,10000,n,m,p)				
		qq=2
		n=25
		m=25
		p=25
		mcP[qq,1::5]=dbelmcP(30000,10000,n,m,p)				
		qq=3
		n=37
		m=45
		p=50
		mcP[qq,1::5]=dbelmcP(30000,10000,n,m,p)	
		
		mcP=(J(3,1,6),mcP)
		mcP
end

		
		
mata:
		mc=(mcA\mcB\mcE\mcF\mcJ\mcM\mcN\mcP)
		
end

cd "E:\STATA Projects\Vexler2- DBEL Project-Tanajian-for WEB SITE\proportion rejected programs\threesample"
getmata (design n m p c05 power)=mc, replace force
export excel design n m p c05 power using prop_rej_3smc_sub, firstrow(variables) replace


