version 12
clear all

cd "E:\STATA Projects\Vexler2- DBEL Project-Tanajian-for WEB SITE\proportion rejected programs\twosample\2s2s_compare_3methods_n_0_1"


/////////////////////two sided two sample ///////////////////////////
mata:
	real scalar function elr(real colvector q1, real colvector qq)
		{
			real colvector m, rm, mm, L, LL, U, UU, qL, qU, F
			real rowvector temp, prodFmat
			real matrix Fmat
			real scalar q1n, qqn, elr
			
			q1n=rows(q1)
			qqn=rows(qq)

			m=(round(q1n^0.6)::min(( round(q1n^.9),round(q1n/2) )))

			rm=m#J(q1n,1,1)
			mm=J(rows(m),1,1)#(1::q1n)

			L=mm-rm
			LL=(L:*(L:>0))+(L:<=0)
			U=mm+rm
			UU=(U:*(U:<=q1n))+(U:>q1n)*q1n

			qL=q1[LL]
			qU=q1[UU]
			
			F=mm_relrank(qq,rows(qq),qU)-mm_relrank(qq,rows(qq),qL)
			F=editvalue(F,0,1/(qqn))
			F=(2*rm):/(q1n*F)
			Fmat=rowshape(F,q1n)
			prodFmat=exp(colsum(log(Fmat)))	
			elr=min(prodFmat)
					
			return(elr)
		}
end


////////////////////////// begin and branch by test ////////////////////////
mata:
	real rowvector dbelmc(real scalar cnum, real scalar pnum, real scalar n, real scalar m)
	{
		real scalar power
		string scalar q
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1)
				z=sort((x\y),1) 
				mcc[nn,1]=log(elr(x,z)*elr(y,z))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				q="x=n(0,1) and y=n(0,1)"
				x = sort(rnormal(n, 1, 0, 1),1)
				y = sort(rnormal(m, 1, 0, 1),1)
				z=sort((x\y),1) 
				mcp[pp,1]=log(elr(x,z)*elr(y,z))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,c05,power)
		return(outresult)
}
end

mata:
		mcA=J(10,4,9)
		qq=1
		n=32
		m=35
		mcA[qq,1::4]=dbelmc(30000,10000,n,m)
		++qq	
		n=32
		m=37
		mcA[qq,1::4]=dbelmc(30000,10000,n,m)
		++qq			
		n=32
		m=40
		mcA[qq,1::4]=dbelmc(30000,10000,n,m)
		++qq
		n=32
		m=50
		mcA[qq,1::4]=dbelmc(30000,10000,n,m)
		++qq
		n=35
		m=37
		mcA[qq,1::4]=dbelmc(30000,10000,n,m)
		++qq	
		n=35
		m=40
		mcA[qq,1::4]=dbelmc(30000,10000,n,m)
		++qq			
		n=35
		m=50
		mcA[qq,1::4]=dbelmc(30000,10000,n,m)
		++qq
		n=37
		m=40
		mcA[qq,1::4]=dbelmc(30000,10000,n,m)
		++qq
		n=37
		m=50
		mcA[qq,1::4]=dbelmc(30000,10000,n,m)
		++qq
		n=40
		m=50
		mcA[qq,1::4]=dbelmc(30000,10000,n,m)				
end

getmata (n m c05 power)=mcA, replace force
export excel n m c05 power using tab1_designMC, firstrow(variables) replace

