version 12
clear all

cd "E:\STATA Projects\Vexler2- DBEL Project-Tanajian-for WEB SITE\proportion rejected programs\twosample\twosampletwosided"


/////////////////////One sided two sample ///////////////////////////
mata:
	real scalar function elr(real colvector q1, real colvector qq)
		{
			real colvector m, rm, mm, L, LL, U, UU, qL, qU, F
			real rowvector temp, prodFmat
			real matrix Fmat
			real scalar q1n, qqn, elr
			
			q1n=rows(q1)
			qqn=rows(qq)

			m=(round(q1n^0.6)::min(( round(q1n^.9),round(q1n/2) )))

			rm=m#J(q1n,1,1)
			mm=J(rows(m),1,1)#(1::q1n)

			L=mm-rm
			LL=(L:*(L:>0))+(L:<=0)
			U=mm+rm
			UU=(U:*(U:<=q1n))+(U:>q1n)*q1n

			qL=q1[LL]
			qU=q1[UU]
			
			F=mm_relrank(qq,rows(qq),qU)-mm_relrank(qq,rows(qq),qL)
			F=editvalue(F,0,1/(qqn))
			F=(2*rm):/(q1n*F)
			Fmat=rowshape(F,q1n)
			prodFmat=exp(colsum(log(Fmat)))	
			elr=min(prodFmat)
					
			return(elr)
		}
end


////////////////////////// begin and branch by test ////////////////////////
mata:
	real rowvector dbelmc(real scalar cnum, real scalar pnum, real scalar n, real scalar m)
	{
		real scalar power
		string scalar q
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1)
				z=sort((x\y),1) 
				mcc[nn,1]=log(elr(x,z)*elr(y,z))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				q="x=n(1,1) and y=n(0,0.5)"
				x = sort(rnormal(n, 1, 1, 1),1)
				y = sort(rnormal(m, 1, 0, 0.5),1)
				z=sort((x\y),1) 
				mcp[pp,1]=log(elr(x,z)*elr(y,z))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,c05,power)
		return(outresult)
}
end

mata:
		mcA=J(42,4,9)
		qq=1
		for (n=5; n<=30; n=n+5) {
			for (m=5; m<=35; m=m+5) {
						mcA[qq,1::4]=dbelmc(30000,10000,n,m)
						++qq
					}
			}	
			
end

getmata (n m c05 power)=mcA, replace force
export excel n m c05 power using tab1_designA, firstrow(variables) replace



////////////////////////// begin and branch by test ////////////////////////
mata:
	real rowvector dbelmcb(real scalar cnum, real scalar pnum, real scalar n, real scalar m)
	{
		real scalar power
		string scalar q
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 
				z=sort((x\y),1) 
				mcc[nn,1]=log(elr(x,z)*elr(y,z))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				
				q="x=n(1,1) and y=n(0,2)"
				x = sort(rnormal(n, 1, 1, 1),1)
				y = sort(rnormal(m, 1, 0, 2),1)		
				z=sort((x\y),1) 
				mcp[pp,1]=log(elr(x,z)*elr(y,z))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
	
		outresult=(n,m,c05,power)
		return(outresult)
}
end

mata:
		mcB=J(42,4,9)
		qq=1
		for (n=5; n<=30; n=n+5) {
			for (m=5; m<=35; m=m+5) {
						mcB[qq,1::4]=dbelmcb(30000,10000,n,m)
						++qq
					}
			}	
			
end

getmata (n m c05 power)=mcB, replace force
export excel n m c05 power using tab1_designB, firstrow(variables) replace




////////////////////////// begin and branch by test ////////////////////////
mata:
	real rowvector dbelmcc(real scalar cnum, real scalar pnum, real scalar n, real scalar m)
	{
		real scalar power
		string scalar q
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 		
				z=sort((x\y),1) 
				mcc[nn,1]=log(elr(x,z)*elr(y,z))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				
				q="x=u(-1,1)+exp(1) and y=u(-1,1)"
				x = sort(( (-1:+(2:*runiform(n,1)))+rgamma(n, 1, 1, 1) ),1) 
				y = sort((-1:+(2:*runiform(m,1))),1)		
				z=sort((x\y),1) 
				mcp[pp,1]=log(elr(x,z)*elr(y,z))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,c05,power)
		return(outresult)
}
end

mata:
		mcC=J(42,4,9)
		qq=1
		for (n=5; n<=30; n=n+5) {
			for (m=5; m<=35; m=m+5) {
						mcC[qq,1::4]=dbelmcc(30000,10000,n,m)
						++qq
					}
			}	
			
end

getmata (n m c05 power)=mcC, replace force
export excel n m c05 power using tab1_designC, firstrow(variables) replace



////////////////////////// begin and branch by test ////////////////////////
mata:
	real rowvector dbelmcd(real scalar cnum, real scalar pnum, real scalar n, real scalar m)
	{
		real scalar power
		string scalar q
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 		
				z=sort((x\y),1) 
				mcc[nn,1]=log(elr(x,z)*elr(y,z))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				q="x=u(0,0.5)+exp(1) and y=exp(1)"
				x = sort(( (0.5:*runiform(n,1))+rgamma(n, 1, 1, 1) ),1) 
				y = sort(rgamma(m, 1, 1, 1),1)		
				z=sort((x\y),1) 
				mcp[pp,1]=log(elr(x,z)*elr(y,z))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,c05,power)
		return(outresult)
}
end

mata:
		mcD=J(42,4,9)
		qq=1
		for (n=5; n<=30; n=n+5) {
			for (m=5; m<=35; m=m+5) {
						mcD[qq,1::4]=dbelmcd(30000,10000,n,m)
						++qq
					}
			}	
			
end

getmata (n m c05 power)=mcD, replace force
export excel n m c05 power using tab1_designD, firstrow(variables) replace








////////////////////////// type I error ////////////////////////
mata:
	real rowvector dbelmcTI(real scalar cnum, real scalar pnum, real scalar n, real scalar m)
	{
		real scalar power
		string scalar q
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 		
				z=sort((x\y),1) 
				mcc[nn,1]=log(elr(x,z)*elr(y,z))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				q="x=n(0,1)x2"
				x = sort(rnormal(n, 1, 0, 1),1)
				y = sort(rnormal(m, 1, 0, 1),1)	
				z=sort((x\y),1) 
				mcp[pp,1]=log(elr(x,z)*elr(y,z))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
		
		outresult=(n,m,c05,power)
		return(outresult)
}
end

mata:
		mcTI=J(2,4,9)
		qq=1
		n=30
		m=37
		mcTI[qq,1::4]=dbelmcTI(30000,10000,n,m)		
end

getmata (n m c05 power)=mcTI, replace force
export excel n m c05 power using tab1_designTI, firstrow(variables) replace





////////////////////////// begin and branch by test ////////////////////////
mata:
	real rowvector dbelmce(real scalar cnum, real scalar pnum, real scalar n, real scalar m)
	{
		real scalar power
		string scalar q
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 
				z=sort((x\y),1) 
				mcc[nn,1]=log(elr(x,z)*elr(y,z))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				
				q="x=logN(1,1) and y=logN(1,0.25)"
				x = sort(exp(rnormal(n, 1, 1, 1)),1)
				y = sort(exp(rnormal(m, 1, 1, 0.25)),1)		
				z=sort((x\y),1) 
				mcp[pp,1]=log(elr(x,z)*elr(y,z))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
	
		outresult=(n,m,c05,power)
		return(outresult)
}
end

mata:
		mcE=J(42,4,9)
		qq=1
		for (n=5; n<=30; n=n+5) {
			for (m=5; m<=35; m=m+5) {
						mcE[qq,1::4]=dbelmce(30000,10000,n,m)
						++qq
					}
			}	
			
end

getmata (n m c05 power)=mcE, replace force
export excel n m c05 power using tab1_designE, firstrow(variables) replace






////////////////////////// begin and branch by test ////////////////////////
mata:
	real rowvector dbelmcf(real scalar cnum, real scalar pnum, real scalar n, real scalar m)
	{
		real scalar power
		string scalar q
		
		mcc=J(cnum,1,0)
		mcp=J(pnum,1,0)
			
		nn=1
		while(nn<=cnum) {   
				x = sort(runiform(n, 1),1)
				y = sort(runiform(m, 1),1) 
				z=sort((x\y),1) 
				mcc[nn,1]=log(elr(x,z)*elr(y,z))
				++nn
			}
		c05=mm_quantile(mcc,1,0.95)
		
		pp=1
		while(pp<=pnum) {
				
				q="x=u(1,2) and y=logN(0,1)"
				x = sort(runiform(n, 1),1):+1
				y = sort(exp(rnormal(m, 1, 0,1)),1)		
				z=sort((x\y),1) 
				mcp[pp,1]=log(elr(x,z)*elr(y,z))
				++pp
			}
	
		power=(colsum(mcp:>=c05))/pnum
	
		outresult=(n,m,c05,power)
		return(outresult)
}
end

mata:
		mcF=J(42,4,9)
		qq=1
		for (n=5; n<=30; n=n+5) {
			for (m=5; m<=35; m=m+5) {
						mcF[qq,1::4]=dbelmcf(30000,10000,n,m)
						++qq
					}
			}	
			
end

getmata (n m c05 power)=mcF, replace force
export excel n m c05 power using tab1_designF, firstrow(variables) replace

















