{smcl}
{* *! version 12.0.0  20dec2012}{...}
{findalias asfradohelp}{...}
{vieweralsosee "" "--"}{...}
{vieweralsosee "[R] help" "help help"}{...}
{viewerjumpto "Syntax" "vxdbel##syntax"}{...}
{viewerjumpto "Description" "vxdbel##description"}{...}
{viewerjumpto "Options" "vxdbel##options"}{...}
{viewerjumpto "Remarks" "vxdbel##remarks"}{...}
{viewerjumpto "Examples" "vxdbel##examples"}{...}
{viewerjumpto "Authors" "vxdbel##authors"}{...}
{title:Title}

{phang}
{bf:vxdbel} {hline 2} Novel and Efficient Distribution Free Density Based Empirical Likelihood Procedure for Symmetry and K-sample Comparisons

{marker syntax}{...}
{title:Syntax}

{p 8 17 2}
{cmdab:vxdbel}
[{varlist}]
[{cmd:,} {it:options}]

{synoptset 25 tabbed}{...}
{synopthdr}
{synoptline}
{syntab:Main}
{synopt:{opt sided(test-description)}}define the test as less, greater or two sided;
	default is {cmd:sided("two.sided")} {p_end}
{synopt:{opt method(method-type)}}define the test method as monte carlo, interpolation, or hybrid;
	default is {cmd:method("interpolation")} {p_end}
{syntab:Monte Carlo}
{synopt:{opt reps(#)}}define the number of monte carlo iterations to obtain the critical value;
	default is {cmd:reps(10000)}{p_end}
{syntab:Bayesian}
{synopt:{opt level(#)}}define significance level for the hybrid method;
	default is {cmd:level(95)}{p_end}
{synoptline}
{p2colreset}{...}


{marker description}{...}
{title:Description}

{pstd}
{cmd:vxdbel} calculates the vxdbel statistic and p-value for the STATA variables in
{varlist}. The test is conducted for one, two or three samples based on the the 
number of STATA variables in {varlist}.  A test of symmetry is conducted for one sample,
and a sample comparison  test is conducted for two and three samples.  
The one and two sample tests are more powerful alternatives to wilcoxon.


{marker options}{...}
{title:Options}

{dlgtab:Main}

{phang}
{opt sided} displays output for one sided or two sided test. {it:greater} and {it:less} perform a one sided test.  {it: two.sided} performs a two sided test. Note: The three sample comparison does not have a one sided test. 

{phang}
{opt method} Defines the method of the test.  {it:mc} defines the method as monte carlo. {it:interpolation} defines the method as interpolation.  {it:hybrid} defines the method as a hybrid of monte carlo and interpolation, based on a bayesian approach.

{phang}
{opt level(#)} specifies the significance level for the hybrid method.  The default is {cmd:level(95)}, meaning that a significance level of 95 is used for the level in the hybrid calculation method.

{phang}
{opt reps(#)} specifies the number of repetitions to use in calculating the critical values for the monte carlo method.  The default is {cmd:reps(10000)}, meaning that 10000 repetitions are used to obtain critical values with monte carlo method.

{marker remarks}{...}
{title:Remarks}

{pstd} For the mc method, the critical values are obtained by monte carlo simulations.  For the hybrid and interpolation methods, the critical values are obtained using a table of critical values already prepared using monte carlo. Note: The table of critical values is complete for sample sizes of less than or equal to thirty, but has gaps for sample sizes greater than thirty. If all sample sizes are less than or equal to thirty then the critical values are available in the table, and results are obtained faster. If all sample sizes are not less than thirty then the hybrid or interpolation method is utilized. 

{pstd} If only one sample (say X) is specified in {varlist}, a test of symmetry is conducted.  If the two sided alternative is specified, a test of the null distribution of X being symmetric about zero is performed.  If a one sided alternative is specified, a test of the null distribution of X being less or greater than zero is performed. 

{pstd} If only two samples (say X and Y) are specified, a two-sample comparison test is conducted.  If the two sided alternative is specified, a test of the null distributions of X and Y being equal is performed.  If a one sided alternative is specified, a test of the null distribution of X being stochastically less or greater than Y is performed.

{pstd} If three samples (say, X, Y, and Z) are specified, a three-sample comparison test is conducted.  A test of the null distributions of X, Y and Z being equal is performed.  

{phang}

{marker examples}{...}
{title:Examples}

{pstd}
 Note1: Assume X, Y, and Z are the names of STATA variables to be tested for Symmetry or K-sample Comparisons. These variables may contain sample data collected during an experiment or data generated using a distribution function(e.g. the STATA rnormal and rgamma function).  For example, X, Y, and Z may be generated as follows:     X = runiform(46,1):-.5; Y = rnormal(25, 1, 0, 1):+1; Z = runiform(46,1):-.5.
 
{phang} Note2:{cmd:sided("two.sided")} and {cmd:method("interpolation")} are the defaults and need not be specified. For hybrid method, {cmd:level(95)} is the default and need not be specified. For mc method, 
cmd:reps(10000)} is the default and need not be specified.

{phang} One-sample:

{phang}{cmd:. vxdbel X, reps(20000) sided("greater") method("mc")}

{phang}{cmd:. vxdbel X, reps(10000) sided("less") method("mc")}

{phang}{cmd:. vxdbel X, method("mc")}

{phang}{cmd:. vxdbel X, sided("greater") method("interpolation")}

{phang}{cmd:. vxdbel X, sided("less")}

{phang}{cmd:. vxdbel X}

{phang}{cmd:. vxdbel X, level(95) sided("greater") method("hybrid")}

{phang}{cmd:. vxdbel X, sided("less") method("hybrid")}

{phang}{cmd:. vxdbel X, method("hybrid")}

{pstd}

{phang} two-sample:

{phang}{cmd:. vxdbel X Y, reps(1000) sided("greater") method("mc")}

{phang}{cmd:. vxdbel X Y, sided("less") method("mc")}

{phang}{cmd:. vxdbel X Y, method("mc")}

{phang}{cmd:. vxdbel X Y, sided("greater") method("interpolation")}

{phang}{cmd:. vxdbel X Y, sided("less")}

{phang}{cmd:. vxdbel X Y}

{phang}{cmd:. vxdbel X Y, sided("greater") method("hybrid")}

{phang}{cmd:. vxdbel X Y, level(0.075) sided("less") method("hybrid")}

{phang}{cmd:. vxdbel X Y, sided("two.sided") method("hybrid")}

{pstd}

{phang} three-sample: 

{phang}{cmd:. vxdbel X Y Z, reps(1000) method("mc")}

{phang}{cmd:. vxdbel X Y Z, method("hybrid")}

{phang}{cmd:. vxdbel X Y Z}

{pstd}


{marker authors}{...}
{title:Authors}

{pstd}
Albert Vexler,
Department of Biostatistics, New York State University at Buffalo, Buffalo, NY 14124, USA
(contact: avexler@buffalo.edu) 

{phang} Hovig Tanajian,
Department of Biostatistics, New York State University at Buffalo, Buffalo, NY 14124, USA

{phang} Alan D. Hutson,
Department of Biostatistics, New York State University at Buffalo, Buffalo, NY 14124, USA


{pstd}

